package de.unimarburg.swt.emf.modelsmell;

import java.io.IOException;
import java.net.URL;
import java.util.Collections;
import java.util.List;
import java.util.LinkedList;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.emf.ecore.EObject;
import de.unimarburg.swt.emf.modelsmell.interfaces.IModelSmellFinderClass;
import de.unimarburg.swt.emf.modelsmell.smellfinder.henshin.HenshinRunner;
import org.eclipse.core.runtime.Path;


public final class NoSpecification implements IModelSmellFinderClass {

	@Override
	public LinkedList<LinkedList<EObject>> findSmell(EObject root) {
		String transformationPath = "transformations/";
		String henshinFileName = "no_specification.henshin";
		String fullPath = getFullPath(transformationPath + henshinFileName);
		return HenshinRunner.run(root, fullPath);
	}
	
	private String getFullPath(String transformationPath){
		URL url = FileLocator.find(de.unimarburg.swt.ecore.smells.Activator.getDefault().getBundle(), new Path(transformationPath), Collections.EMPTY_MAP);
		URL fileUrl = null;
		try {
		fileUrl = FileLocator.toFileURL(url);
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		return 	fileUrl.getPath();
	}
	
}